'''
==================
||Importing Libs||
==================
'''
import es # Imports the es methods.
import random # Imports the random methods.
import effectlib # Imports the effectlib methods.
import gamethread # Imports the gamethread methods.
import psyco # Imports the psyco methods.
psyco.full() # Starts psyco, this makes the addon faster.
'''
=====================
||Addon Information||
=====================
'''
addon = {
    "name"       : "Air Bomb", # Addon Name
    "version"    : "0.1", # Addon Version
    "date"       : "11.08.2010", # Addon Creation Date
    "author"     : "MiB", # Addon Author
    "description": "Sets the bomb in the air and displays effects in the air.", # Addon Description
    "url"        : "http://warcraft-source.com", # Addon URL
    "basename"   : "airbomb", # Addon Basename
}
info = es.AddonInfo()
for fo in addon:
    info[fo] = addon[fo]
es.ServerVar(info['basename'], info['version'], info['description']).makepublic()
'''
==========
||Config||
==========
'''
ab_msg = 1 # Set to 1 to show the air bomb message. (1 Default)
ab_air = 1 # Set to 1 to put the bomb in the air. (1 Default)
ab_power = 125 # How high do you want the bomb to be put in the air. (125 Default)
ab_effect = 1 # Set to 1 to show the effect. (1 Default)
ab_model = "sprites/physcannon_bluecore1.vmt" # Sets what model the effect will be. ("sprites/physcannon_bluecore1.vmt" Default)
ab_snd = "0" # Sets the sound that will play when the player plants the bomb. ("0" Default/Disabled)
ab_snd_volume = 1.0 # How loud is the sound. (1.0 Max/Default)
ab_snd_dist = 0.5 # How far it reaches across the map. (0.5 Default)
'''
=============
||Variables||
=============
'''
rnd = 0 # Sets "rnd" to 0 so it can tell the script that the round is not started.
'''
=====================
||Round Start Event||
=====================
'''
def round_start(ev):
    global rnd # Makes the python variable "rnd" for global script use.
    rnd = 1 # Sets "rnd" to 1 so it can tell the script that the round is started.
'''
===================
||Round End Event||
===================
'''
def round_end(ev):
    global rnd # Makes the python variable "rnd" for global script use.
    rnd = 0 # Sets "rnd" to 0 so it can tell the script that the round is not started.
'''
======================
||Bomb Planted Event||
======================
'''
def bomb_planted(ev):
    if ab_air == 1: # Checks if message is 1.
        es.centermsg("-Air Bomb- Activated") # Sends message to everyone.
    index = es.getentityindex("planted_c4") # Gets the bomb's index.
    origin = es.getindexprop(index,"CPlantedC4.baseclass.baseclass.m_vecOrigin") # Gets the bomb's vector origin.
    if ab_air == 1: # Checks if air bomb is 1.
        x,y,z = origin.split(",") # Splits x,y and z vectors into 3 different variables.
        z = float(z) + float(ab_power) # Adds the ab_power variable to the z vector.
        origin = "%s,%s,%s"%(x,y,z) # Rewrites the origin variable.
        es.setindexprop(index,"CPlantedC4.baseclass.baseclass.m_vecOrigin",origin) # Sets the bomb's new location.
    if ab_snd != "0" and ab_snd != 0: # Checks if its a sound.
        es.emitsound("entity",index,ab_snd,ab_snd_volume,ab_snd_dist) # Plays the sound.
    if ab_effect == 1: # Checks to see if effect is 1.
        if rnd == 1: # Checks if round is started.
            r = random.randint(1,255) # Gets a random red hex value.
            g = random.randint(1,255) # Gets a random green hex value.
            b = random.randint(1,255) # Gets a random blue hex value.
            effectlib.drawCircle(origin,radius=50,steps=20,halo=ab_model,model=ab_model,seconds=0.3,width=5,endwidth=5,red=r,green=g,blue=b) # Makes the ring effect.
            if ab_air == 1: # Checks if air bomb is 1.
                origin2 = origin # Copys the origin vectors.
                x,y,z = origin2.split(",") # Splits x,y and z vectors into 3 different variables.
                z = float(z) - float(ab_power) # Subtracts the ab_power variable from the z vector.
                origin2 = "%s,%s,%s"%(x,y,z) # Rewrites the origin2 variable.
                effectlib.drawLine(origin,origin2,halo=ab_model,model=ab_model,seconds=0.3,width=5,endwidth=5,red=r,green=g,blue=b) # Makes the line effect.
            gamethread.delayed(0.3,bomb_effect,origin) # Starts up the effect loop.    
'''
=======================
||Bomb Planted Method||
=======================
'''
def bomb_effect(origin):
    if ab_effect == 1: # Checks to see if effect is 1.
        if rnd == 1: # Checks if round is started.
            r = random.randint(1,255) # Gets a random red hex value.
            g = random.randint(1,255) # Gets a random green hex value.
            b = random.randint(1,255) # Gets a random blue hex value.
            effectlib.drawCircle(origin,radius=50,steps=20,halo=ab_model,model=ab_model,seconds=0.3,width=5,endwidth=5,red=r,green=g,blue=b) # Makes the ring effect.
            if ab_air == 1: # Checks if air bomb is 1.
                origin2 = origin # Copys the origin vectors.
                x,y,z = origin2.split(",") # Splits x,y and z vectors into 3 different variables.
                z = float(z) - float(ab_power) # Subtracts the ab_power variable from the z vector.
                origin2 = "%s,%s,%s"%(x,y,z) # Rewrites the origin2 variable.
                effectlib.drawLine(origin,origin2,halo=ab_model,model=ab_model,seconds=0.3,width=5,endwidth=5,red=r,green=g,blue=b) # Makes the line effect.
            gamethread.delayed(0.3,bomb_effect,origin) # Continues the effect loop.